const Discord = require('discord.js');
const client = new Discord.Client();
var replyChannelId;
var mentionedChannelId;
var hugGifs =
        ["https://c.tenor.com/9e1aE_xBLCsAAAAC/anime-hug.gif",
         "https://c.tenor.com/Ct4bdr2ZGeAAAAAC/teria-wang-kishuku-gakkou-no-juliet.gif",
         "https://c.tenor.com/ztEJgrjFe54AAAAd/hug-anime.gif",
         "https://c.tenor.com/UhcyGsGpLNIAAAAd/hug-anime.gif",
         "https://c.tenor.com/fLxZt7jo1YEAAAAd/loli-dragon.gif",
         "https://c.tenor.com/qF7mO4nnL0sAAAAd/abra%C3%A7o-hug.gif"]


client.once('ready', () => {
    console.log('Running');
});

client.on('message', message => {

    let msg = message.content.toLowerCase();

    if(message.content.includes(":USureBoutThat:")){
        message.channel.send("<:ugh:802988623271428117>");
    }

  if(message.content.includes('https://media.discordapp.net')) {
    if(message.content.includes('webm') || message.content.includes('mov') ||
    message.content.includes('mp4')) {
    let linkArr = message.content.split('https://media.discordapp.net');
    message.channel.send('https://cdn.discordapp.com' +linkArr[1])
    } 
}

    var msgContent = message.content

    var msgContentSplit = msgContent.split(/[ ]+/);

    if(message.reference != null){

        if(msgContentSplit.length == 1 && message.mentions.channels.first() != undefined){

            var replyMessageId = message.reference.messageID;

            mentionedChannelId = msgContentSplit[0].substring(2, msgContentSplit[0].length - 1);
            replyChannelId = message.reference.channelID;

            var replyChannel = client.channels.cache.find(channel => channel.id === replyChannelId);

            replyChannel.messages.fetch(replyMessageId).then(msg => {
                var movedMessageContent;
                if(msg.attachments.size > 0){
                    allAttachments = msg.attachments.values()
                    movedMessageContent = [];
                    for (let i = 0; i < msg.attachments.size; i++) {
                        currAttachment = allAttachments.next().value
                        movedMessageContent.push(new Discord.MessageAttachment(currAttachment.url));
                    }
                    client.channels.cache.get(mentionedChannelId).send(movedMessageContent).then(msgToEdit => {
                        msgToEdit.edit("Sent by <@" + msg.author + "> \nmooved <@" + message.author + ">\n" + msgToEdit.content);
                    });
                }
                else{
                    movedMessageContent = msg.content;
                    client.channels.cache.get(mentionedChannelId).send(movedMessageContent).then(msgToEdit => {
                            msgToEdit.edit("Sent by <@" + msg.author + "> \nmooved <@" + message.author + ">\n" + msgToEdit.content);
                    });
                }
                msg.delete({timeout: 3000});
            });
            message.delete({timeout: 3000});
        }
    }

    if (msg.startsWith("henlo") && message.author.bot == false) {
        var emojis = ["🥰", "🐄", "🐮", "❤️", "👋", "🤠", "😊"];
        let randomNum = RNG(emojis.length);
        message.channel.send("Henlooo " + message.author.username + "   " + emojis[randomNum]);
    }
    else if (msg.startsWith("how ye") && message.author.bot === false) {
        var responses = ["Not bad, how yee?", "MOOdy", "A bit sad 😢", "Good, how yee?", "I'm fine, how yee?"];
        let randomNum = RNG(responses.length);
        message.channel.send(responses[randomNum]);
    }
    else if (msg.startsWith("tylko jedno")) {
        message.channel.send("Koksu pięć gram odlecieć sam");
    }
    if (msg.startsWith("hug") && msgContentSplit.length < 3) {
        var mentionedUsers = message.mentions.users.values()
        var mentionedUsersSize = message.mentions.users.size
        var mentionedRoles = message.mentions.roles.values()
        var mentionedRolesSize = message.mentions.roles.size
        
        let randomNum = RNG(hugGifs.length)
        title = message.author.username + " hugs"
        if (mentionedUsersSize > 0 || mentionedRolesSize > 0){
            let allMentions = ""
            for (let i = 0; i < mentionedUsersSize; i++) {
                let user = mentionedUsers.next()
                allMentions = allMentions + ", <@" + user.value.id + ">"
            }
            for (let i = 0; i < mentionedRolesSize; i++) {
                let role = mentionedRoles.next()
                allMentions = allMentions + ", <@&" + role.value.id + ">"
            }
            allMentions = allMentions.slice(2)
            embed = createEmbed(title, hugGifs[randomNum], allMentions)
            message.channel.send(embed)
        }
        else if (msg.includes("@here")){
            embed = createEmbed(title, hugGifs[randomNum], "@here")
            message.channel.send(embed)
        }
        else if (msg.includes("@everyone")){
            embed = createEmbed(title, hugGifs[randomNum], "@everyone")
            message.channel.send(embed)
        }
        else if (msg.includes("all")){
            embed = createEmbed(title, hugGifs[randomNum], "@here")
            message.channel.send(embed)
        }
        else {
            embed = new Discord.MessageEmbed().setImage(hugGifs[randomNum]).setColor(randomColor())
            message.channel.send(embed)
        }
    }
});

function createEmbed(title, img, desc){
    embed = new Discord.MessageEmbed()
            .setTitle(title)
            .setImage(img)
            .setDescription(desc)
            .setColor(randomColor())
    return embed
}

function randomColor() {
    let color = '#';
    for (let i = 0; i < 6; i++){
       const random = Math.random();
       const bit = (random * 16) | 0;
       color += (bit).toString(16);
    };
    return color;
 };

function RNG(max){
    return Math.floor(Math.random() * max)
}

client.login(process.env.token)
